CONFIG +=			release \
					warn_on \
					qt \
					thread 

TEMPLATE =			app
DESTDIR =			bin

CONFIG(debug, debug|release) {
	TARGET =		mcgd
} else {
	TARGET =		mcg
}

OBJECTS_DIR =		build/obj
MOC_DIR =			build/moc

QT +=				core \
					gui \
					opengl \
					xml

greaterThan(QT_MAJOR_VERSION, 4): {
QT +=				widgets \
					printsupport

}

SOURCES +=			../core/bestfitsphere.cpp \
					../core/graphwidget.cpp \
					../core/mat4.cpp \
					../core/messagebox.cpp \
					../core/openglgeometryfactory.cpp \
					../core/openglvertexbuffer.cpp \
					../core/openglwidget.cpp \
					../core/referencesystem.cpp \
					../core/vector2.cpp \
					../core/vector3.cpp \
					../core/xmlfile.cpp \
					src/analysiswidget.cpp \
					src/main.cpp \
					src/mcg.cpp \
					src/pathwidget.cpp \
					src/program_dmis.cpp \
					src/measurement.cpp \
					src/opengldisplay.cpp \
					src/opengldisplaymcg.cpp \
					src/opengldisplaywidget.cpp \
					src/reportwidget.cpp \
					src/selectiondialog.cpp \
					src/tolerancewidget.cpp

HEADERS +=			../core/bestfitsphere.h \
					../core/graphwidget.h \
					../core/mat4.h \
					../core/messagebox.h \
					../core/openglgeometryfactory.h \
					../core/openglvertexbuffer.h \
					../core/openglwidget.h \
					../core/referencesystem.h \
					../core/vector2.h \
					../core/vector3.h \
					../core/xmlfile.h \
					src/analysiswidget.h \
					src/mcg.h \
					src/pathwidget.h \
					src/program_dmis.h \
					src/measurement.h \
					src/opengldisplay.h \
					src/opengldisplaymcg.h \
					src/opengldisplaywidget.h \
					src/reportwidget.h \
					src/selectiondialog.h \
					src/tolerancewidget.h

RESOURCES +=		res/mcg.qrc

macx{

ICON =				res/icons.icns
OBJECTIVE_SOURCES += ../core/nspool.mm
HEADERS += 			../core/nspool.mm
LIBS +=				-framework AppKit -framework Cocoa

QMAKE_INFO_PLIST = ../default_data/Info.plist
}

linux-g++{

isEmpty(PREFIX) {
PREFIX = 			/usr/lib/mcg
}
target.path =		$$PREFIX
target.files =		bin/mcg
INSTALLS +=			target

# QMAKE_POST_LINK = patchelf --set-rpath ./qtlibs bin/mcg
}

win32 {
RC_FILE =			res/resource.rc
}
