/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2023  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef ANALYSISWIDGETHEADERFILE
#define ANALYSISWIDGETHEADERFILE

#include <QWidget>
#include <QColor>

#include "../../core/graphwidget.h"
#include "../../core/vector2.h"

class QPlainTextEdit;
class TGraphWidget;

class TAnalysisWidget : public QWidget
{
	Q_OBJECT
	
public:
	
	// CREATORS
	TAnalysisWidget(const QWidget *parent=0, Qt::WindowFlags flags=Qt::WindowFlags());
	~TAnalysisWidget(void);
	
	// ACCESSORS
	
	// MANIPULATORS
	void Clear(void);
	
	int Create_Graph_Set(const QColor &color,const TGraphWidget::TGraphType type = TGraphWidget::DEFAULT_GRAPH);
	void Add_Point_Graph(const int &set,const TVector2 &pnt);
	void Scale_To_Fit_Graph(void);
	
	void Add_Text(const QString &text);
	void Add_Text_End(void);
	
signals:
	
	private slots:
	
private:
	
	QPlainTextEdit						*d_analysis_text_edit;
	TGraphWidget						*d_analysis_graph_widget;
	
	// NOT IMPLEMENTED
	TAnalysisWidget(const TAnalysisWidget&);
	TAnalysisWidget& operator=(const TAnalysisWidget&);
};

#endif
