/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2023  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef OPENGLDISPLAYMCGHEADERFILE
#define OPENGLDISPLAYMCGHEADERFILE

#include "../../core/vector3.h"
#include "opengldisplay.h"

namespace MCG
{
struct TMCGData
{
	TVector3							color;
	GLenum								mode;
	std::vector<TVector3>				verticies;
	std::vector<TVector3>				normals;
};
	
	std::vector<TMCGData> Render_MCG_Base(const TVector3 &pos);
	std::vector<TMCGData> Render_MCG_Arm(const TVector3 &pos,const TVector3 &axis,const double &length);
};

#endif
