/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2023  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef PROGRAMDMISHEADERFILE
#define PROGRAMDMISHEADERFILE

#include <QFile>
#include <vector>

#include "../../core/vector3.h"

#include "pathwidget.h"

class TProgramDMIS
{
public:
// CREATORS
	TProgramDMIS(void);
	~TProgramDMIS(void);
	
// ACCESSORS
	
// MANIPULATORS
	
	bool Create_Program(const QString &file_name,const std::vector<TPathWidget::TPathPoint> &path_points,const double &arm_length);
	
//	bool Create_DMIS_Program(const QString &file_name,const TVector3 &load_pos);
//	void Create_DMIS_Program_End(void);
	
private:
	
	QFile								d_file;
	
	void Add_Move_Point(const TVector3 &pnt);
	void Add_Touch_Point(const QString &name,const TVector3 &pnt,const TVector3 &vec);
	void Add_Sphere_5(const QString &name,const TVector3 &pos,const double &radius);
	void Add_Sphere_25(const QString &name,const TVector3 &pos,const double &radius);
	void Report_Feature_Position(const QString &name);
	void Report_Feature_Form(const QString &name);

	void Create_Header(const QString &comment_text);
	bool Write_Line(const QString &line);

	
// NOT IMPLEMENTED
	TProgramDMIS(const TProgramDMIS&);
	TProgramDMIS& operator=(const TProgramDMIS&);
	
};

#endif
